# coding: utf-8

"""
    MailSlurp API

    MailSlurp is an API for sending and receiving emails from dynamically allocated email addresses. It's designed for developers and QA teams to test applications, process inbound emails, send templated notifications, attachments, and more.  ## Resources  - [Homepage](https://www.mailslurp.com) - Get an [API KEY](https://app.mailslurp.com/sign-up/) - Generated [SDK Clients](https://www.mailslurp.com/docs/) - [Examples](https://github.com/mailslurp/examples) repository  # noqa: E501

    The version of the OpenAPI document: 6.5.2
    Contact: contact@mailslurp.dev
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from mailslurp_client.configuration import Configuration


class GetOrCreateSamlUserOptions(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'issuer': 'str',
        'name_id': 'str',
        'name_id_format': 'str'
    }

    attribute_map = {
        'issuer': 'issuer',
        'name_id': 'nameId',
        'name_id_format': 'nameIdFormat'
    }

    def __init__(self, issuer=None, name_id=None, name_id_format=None, local_vars_configuration=None):  # noqa: E501
        """GetOrCreateSamlUserOptions - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._issuer = None
        self._name_id = None
        self._name_id_format = None
        self.discriminator = None

        self.issuer = issuer
        self.name_id = name_id
        if name_id_format is not None:
            self.name_id_format = name_id_format

    @property
    def issuer(self):
        """Gets the issuer of this GetOrCreateSamlUserOptions.  # noqa: E501


        :return: The issuer of this GetOrCreateSamlUserOptions.  # noqa: E501
        :rtype: str
        """
        return self._issuer

    @issuer.setter
    def issuer(self, issuer):
        """Sets the issuer of this GetOrCreateSamlUserOptions.


        :param issuer: The issuer of this GetOrCreateSamlUserOptions.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and issuer is None:  # noqa: E501
            raise ValueError("Invalid value for `issuer`, must not be `None`")  # noqa: E501

        self._issuer = issuer

    @property
    def name_id(self):
        """Gets the name_id of this GetOrCreateSamlUserOptions.  # noqa: E501


        :return: The name_id of this GetOrCreateSamlUserOptions.  # noqa: E501
        :rtype: str
        """
        return self._name_id

    @name_id.setter
    def name_id(self, name_id):
        """Sets the name_id of this GetOrCreateSamlUserOptions.


        :param name_id: The name_id of this GetOrCreateSamlUserOptions.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and name_id is None:  # noqa: E501
            raise ValueError("Invalid value for `name_id`, must not be `None`")  # noqa: E501

        self._name_id = name_id

    @property
    def name_id_format(self):
        """Gets the name_id_format of this GetOrCreateSamlUserOptions.  # noqa: E501


        :return: The name_id_format of this GetOrCreateSamlUserOptions.  # noqa: E501
        :rtype: str
        """
        return self._name_id_format

    @name_id_format.setter
    def name_id_format(self, name_id_format):
        """Sets the name_id_format of this GetOrCreateSamlUserOptions.


        :param name_id_format: The name_id_format of this GetOrCreateSamlUserOptions.  # noqa: E501
        :type: str
        """

        self._name_id_format = name_id_format

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GetOrCreateSamlUserOptions):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, GetOrCreateSamlUserOptions):
            return True

        return self.to_dict() != other.to_dict()
